// Code generated by gotdgen, DO NOT EDIT.

package tdapi

import (
	"context"
	"errors"
	"fmt"
	"sort"
	"strings"

	"go.uber.org/multierr"

	"github.com/gotd/td/bin"
	"github.com/gotd/td/tdjson"
	"github.com/gotd/td/tdp"
	"github.com/gotd/td/tgerr"
)

// No-op definition for keeping imports.
var (
	_ = bin.Buffer{}
	_ = context.Background()
	_ = fmt.Stringer(nil)
	_ = strings.Builder{}
	_ = errors.Is
	_ = multierr.AppendInto
	_ = sort.Ints
	_ = tdp.Format
	_ = tgerr.Error{}
	_ = tdjson.Encoder{}
)

// AssignGooglePlayTransactionRequest represents TL type `assignGooglePlayTransaction#51fc383d`.
type AssignGooglePlayTransactionRequest struct {
	// Google Play purchase token
	PurchaseToken string
}

// AssignGooglePlayTransactionRequestTypeID is TL type id of AssignGooglePlayTransactionRequest.
const AssignGooglePlayTransactionRequestTypeID = 0x51fc383d

// Ensuring interfaces in compile-time for AssignGooglePlayTransactionRequest.
var (
	_ bin.Encoder     = &AssignGooglePlayTransactionRequest{}
	_ bin.Decoder     = &AssignGooglePlayTransactionRequest{}
	_ bin.BareEncoder = &AssignGooglePlayTransactionRequest{}
	_ bin.BareDecoder = &AssignGooglePlayTransactionRequest{}
)

func (a *AssignGooglePlayTransactionRequest) Zero() bool {
	if a == nil {
		return true
	}
	if !(a.PurchaseToken == "") {
		return false
	}

	return true
}

// String implements fmt.Stringer.
func (a *AssignGooglePlayTransactionRequest) String() string {
	if a == nil {
		return "AssignGooglePlayTransactionRequest(nil)"
	}
	type Alias AssignGooglePlayTransactionRequest
	return fmt.Sprintf("AssignGooglePlayTransactionRequest%+v", Alias(*a))
}

// TypeID returns type id in TL schema.
//
// See https://core.telegram.org/mtproto/TL-tl#remarks.
func (*AssignGooglePlayTransactionRequest) TypeID() uint32 {
	return AssignGooglePlayTransactionRequestTypeID
}

// TypeName returns name of type in TL schema.
func (*AssignGooglePlayTransactionRequest) TypeName() string {
	return "assignGooglePlayTransaction"
}

// TypeInfo returns info about TL type.
func (a *AssignGooglePlayTransactionRequest) TypeInfo() tdp.Type {
	typ := tdp.Type{
		Name: "assignGooglePlayTransaction",
		ID:   AssignGooglePlayTransactionRequestTypeID,
	}
	if a == nil {
		typ.Null = true
		return typ
	}
	typ.Fields = []tdp.Field{
		{
			Name:       "PurchaseToken",
			SchemaName: "purchase_token",
		},
	}
	return typ
}

// Encode implements bin.Encoder.
func (a *AssignGooglePlayTransactionRequest) Encode(b *bin.Buffer) error {
	if a == nil {
		return fmt.Errorf("can't encode assignGooglePlayTransaction#51fc383d as nil")
	}
	b.PutID(AssignGooglePlayTransactionRequestTypeID)
	return a.EncodeBare(b)
}

// EncodeBare implements bin.BareEncoder.
func (a *AssignGooglePlayTransactionRequest) EncodeBare(b *bin.Buffer) error {
	if a == nil {
		return fmt.Errorf("can't encode assignGooglePlayTransaction#51fc383d as nil")
	}
	b.PutString(a.PurchaseToken)
	return nil
}

// Decode implements bin.Decoder.
func (a *AssignGooglePlayTransactionRequest) Decode(b *bin.Buffer) error {
	if a == nil {
		return fmt.Errorf("can't decode assignGooglePlayTransaction#51fc383d to nil")
	}
	if err := b.ConsumeID(AssignGooglePlayTransactionRequestTypeID); err != nil {
		return fmt.Errorf("unable to decode assignGooglePlayTransaction#51fc383d: %w", err)
	}
	return a.DecodeBare(b)
}

// DecodeBare implements bin.BareDecoder.
func (a *AssignGooglePlayTransactionRequest) DecodeBare(b *bin.Buffer) error {
	if a == nil {
		return fmt.Errorf("can't decode assignGooglePlayTransaction#51fc383d to nil")
	}
	{
		value, err := b.String()
		if err != nil {
			return fmt.Errorf("unable to decode assignGooglePlayTransaction#51fc383d: field purchase_token: %w", err)
		}
		a.PurchaseToken = value
	}
	return nil
}

// EncodeTDLibJSON implements tdjson.TDLibEncoder.
func (a *AssignGooglePlayTransactionRequest) EncodeTDLibJSON(b tdjson.Encoder) error {
	if a == nil {
		return fmt.Errorf("can't encode assignGooglePlayTransaction#51fc383d as nil")
	}
	b.ObjStart()
	b.PutID("assignGooglePlayTransaction")
	b.Comma()
	b.FieldStart("purchase_token")
	b.PutString(a.PurchaseToken)
	b.Comma()
	b.StripComma()
	b.ObjEnd()
	return nil
}

// DecodeTDLibJSON implements tdjson.TDLibDecoder.
func (a *AssignGooglePlayTransactionRequest) DecodeTDLibJSON(b tdjson.Decoder) error {
	if a == nil {
		return fmt.Errorf("can't decode assignGooglePlayTransaction#51fc383d to nil")
	}

	return b.Obj(func(b tdjson.Decoder, key []byte) error {
		switch string(key) {
		case tdjson.TypeField:
			if err := b.ConsumeID("assignGooglePlayTransaction"); err != nil {
				return fmt.Errorf("unable to decode assignGooglePlayTransaction#51fc383d: %w", err)
			}
		case "purchase_token":
			value, err := b.String()
			if err != nil {
				return fmt.Errorf("unable to decode assignGooglePlayTransaction#51fc383d: field purchase_token: %w", err)
			}
			a.PurchaseToken = value
		default:
			return b.Skip()
		}
		return nil
	})
}

// GetPurchaseToken returns value of PurchaseToken field.
func (a *AssignGooglePlayTransactionRequest) GetPurchaseToken() (value string) {
	if a == nil {
		return
	}
	return a.PurchaseToken
}

// AssignGooglePlayTransaction invokes method assignGooglePlayTransaction#51fc383d returning error if any.
func (c *Client) AssignGooglePlayTransaction(ctx context.Context, purchasetoken string) error {
	var ok Ok

	request := &AssignGooglePlayTransactionRequest{
		PurchaseToken: purchasetoken,
	}
	if err := c.rpc.Invoke(ctx, request, &ok); err != nil {
		return err
	}
	return nil
}
