// Code generated by gotdgen, DO NOT EDIT.

package tdapi

import (
	"context"
	"errors"
	"fmt"
	"sort"
	"strings"

	"go.uber.org/multierr"

	"github.com/gotd/td/bin"
	"github.com/gotd/td/tdjson"
	"github.com/gotd/td/tdp"
	"github.com/gotd/td/tgerr"
)

// No-op definition for keeping imports.
var (
	_ = bin.Buffer{}
	_ = context.Background()
	_ = fmt.Stringer(nil)
	_ = strings.Builder{}
	_ = errors.Is
	_ = multierr.AppendInto
	_ = sort.Ints
	_ = tdp.Format
	_ = tgerr.Error{}
	_ = tdjson.Encoder{}
)

// GetUserFullInfoRequest represents TL type `getUserFullInfo#d1b29c58`.
type GetUserFullInfoRequest struct {
	// User identifier
	UserID int64
}

// GetUserFullInfoRequestTypeID is TL type id of GetUserFullInfoRequest.
const GetUserFullInfoRequestTypeID = 0xd1b29c58

// Ensuring interfaces in compile-time for GetUserFullInfoRequest.
var (
	_ bin.Encoder     = &GetUserFullInfoRequest{}
	_ bin.Decoder     = &GetUserFullInfoRequest{}
	_ bin.BareEncoder = &GetUserFullInfoRequest{}
	_ bin.BareDecoder = &GetUserFullInfoRequest{}
)

func (g *GetUserFullInfoRequest) Zero() bool {
	if g == nil {
		return true
	}
	if !(g.UserID == 0) {
		return false
	}

	return true
}

// String implements fmt.Stringer.
func (g *GetUserFullInfoRequest) String() string {
	if g == nil {
		return "GetUserFullInfoRequest(nil)"
	}
	type Alias GetUserFullInfoRequest
	return fmt.Sprintf("GetUserFullInfoRequest%+v", Alias(*g))
}

// TypeID returns type id in TL schema.
//
// See https://core.telegram.org/mtproto/TL-tl#remarks.
func (*GetUserFullInfoRequest) TypeID() uint32 {
	return GetUserFullInfoRequestTypeID
}

// TypeName returns name of type in TL schema.
func (*GetUserFullInfoRequest) TypeName() string {
	return "getUserFullInfo"
}

// TypeInfo returns info about TL type.
func (g *GetUserFullInfoRequest) TypeInfo() tdp.Type {
	typ := tdp.Type{
		Name: "getUserFullInfo",
		ID:   GetUserFullInfoRequestTypeID,
	}
	if g == nil {
		typ.Null = true
		return typ
	}
	typ.Fields = []tdp.Field{
		{
			Name:       "UserID",
			SchemaName: "user_id",
		},
	}
	return typ
}

// Encode implements bin.Encoder.
func (g *GetUserFullInfoRequest) Encode(b *bin.Buffer) error {
	if g == nil {
		return fmt.Errorf("can't encode getUserFullInfo#d1b29c58 as nil")
	}
	b.PutID(GetUserFullInfoRequestTypeID)
	return g.EncodeBare(b)
}

// EncodeBare implements bin.BareEncoder.
func (g *GetUserFullInfoRequest) EncodeBare(b *bin.Buffer) error {
	if g == nil {
		return fmt.Errorf("can't encode getUserFullInfo#d1b29c58 as nil")
	}
	b.PutInt53(g.UserID)
	return nil
}

// Decode implements bin.Decoder.
func (g *GetUserFullInfoRequest) Decode(b *bin.Buffer) error {
	if g == nil {
		return fmt.Errorf("can't decode getUserFullInfo#d1b29c58 to nil")
	}
	if err := b.ConsumeID(GetUserFullInfoRequestTypeID); err != nil {
		return fmt.Errorf("unable to decode getUserFullInfo#d1b29c58: %w", err)
	}
	return g.DecodeBare(b)
}

// DecodeBare implements bin.BareDecoder.
func (g *GetUserFullInfoRequest) DecodeBare(b *bin.Buffer) error {
	if g == nil {
		return fmt.Errorf("can't decode getUserFullInfo#d1b29c58 to nil")
	}
	{
		value, err := b.Int53()
		if err != nil {
			return fmt.Errorf("unable to decode getUserFullInfo#d1b29c58: field user_id: %w", err)
		}
		g.UserID = value
	}
	return nil
}

// EncodeTDLibJSON implements tdjson.TDLibEncoder.
func (g *GetUserFullInfoRequest) EncodeTDLibJSON(b tdjson.Encoder) error {
	if g == nil {
		return fmt.Errorf("can't encode getUserFullInfo#d1b29c58 as nil")
	}
	b.ObjStart()
	b.PutID("getUserFullInfo")
	b.Comma()
	b.FieldStart("user_id")
	b.PutInt53(g.UserID)
	b.Comma()
	b.StripComma()
	b.ObjEnd()
	return nil
}

// DecodeTDLibJSON implements tdjson.TDLibDecoder.
func (g *GetUserFullInfoRequest) DecodeTDLibJSON(b tdjson.Decoder) error {
	if g == nil {
		return fmt.Errorf("can't decode getUserFullInfo#d1b29c58 to nil")
	}

	return b.Obj(func(b tdjson.Decoder, key []byte) error {
		switch string(key) {
		case tdjson.TypeField:
			if err := b.ConsumeID("getUserFullInfo"); err != nil {
				return fmt.Errorf("unable to decode getUserFullInfo#d1b29c58: %w", err)
			}
		case "user_id":
			value, err := b.Int53()
			if err != nil {
				return fmt.Errorf("unable to decode getUserFullInfo#d1b29c58: field user_id: %w", err)
			}
			g.UserID = value
		default:
			return b.Skip()
		}
		return nil
	})
}

// GetUserID returns value of UserID field.
func (g *GetUserFullInfoRequest) GetUserID() (value int64) {
	if g == nil {
		return
	}
	return g.UserID
}

// GetUserFullInfo invokes method getUserFullInfo#d1b29c58 returning error if any.
func (c *Client) GetUserFullInfo(ctx context.Context, userid int64) (*UserFullInfo, error) {
	var result UserFullInfo

	request := &GetUserFullInfoRequest{
		UserID: userid,
	}
	if err := c.rpc.Invoke(ctx, request, &result); err != nil {
		return nil, err
	}
	return &result, nil
}
